package schools

import (
    ida96af0f171bb75f894a4013a6b3146a4397c58f11adb81a2b7cbea9314783a9 "github.com/microsoft/kiota/abstractions/go"
    i04eb5309aeaafadd28374d79c8471df9b267510b4dc2e3144c378c50f6fd7b55 "github.com/microsoft/kiota/abstractions/go/serialization"
    ia797412c79037d67c12341f9d33f0894f60de15efd7141a5da5711a83a65bdfd "github.com/microsoftgraph/msgraph-sdk-go/education/me/schools/delta"
    icc60562432d4afffaa419e6465a245e8f2b2cf6cd3cb8567d34813eb83c95532 "github.com/microsoftgraph/msgraph-sdk-go/education/me/schools/ref"
)

// SchoolsRequestBuilder builds and executes requests for operations under \education\me\schools
type SchoolsRequestBuilder struct {
    // Path parameters for the request
    pathParameters map[string]string;
    // The request adapter to use to execute the requests.
    requestAdapter ida96af0f171bb75f894a4013a6b3146a4397c58f11adb81a2b7cbea9314783a9.RequestAdapter;
    // Url template to use to build the URL for the current request builder
    urlTemplate string;
}
// SchoolsRequestBuilderGetOptions options for Get
type SchoolsRequestBuilderGetOptions struct {
    // Request headers
    H map[string]string;
    // Request options
    O []ida96af0f171bb75f894a4013a6b3146a4397c58f11adb81a2b7cbea9314783a9.RequestOption;
    // Request query parameters
    Q *SchoolsRequestBuilderGetQueryParameters;
    // Response handler to use in place of the default response handling provided by the core service
    ResponseHandler ida96af0f171bb75f894a4013a6b3146a4397c58f11adb81a2b7cbea9314783a9.ResponseHandler;
}
// SchoolsRequestBuilderGetQueryParameters schools to which the user belongs. Nullable.
type SchoolsRequestBuilderGetQueryParameters struct {
    // Include count of items
    Count *bool;
    // Expand related entities
    Expand []string;
    // Filter items by property values
    Filter *string;
    // Order items by property values
    Orderby []string;
    // Search items by search phrases
    Search *string;
    // Select properties to be returned
    Select []string;
    // Skip the first n items
    Skip *int32;
    // Show only the first n items
    Top *int32;
}
// NewSchoolsRequestBuilderInternal instantiates a new SchoolsRequestBuilder and sets the default values.
func NewSchoolsRequestBuilderInternal(pathParameters map[string]string, requestAdapter ida96af0f171bb75f894a4013a6b3146a4397c58f11adb81a2b7cbea9314783a9.RequestAdapter)(*SchoolsRequestBuilder) {
    m := &SchoolsRequestBuilder{
    }
    m.urlTemplate = "{+baseurl}/education/me/schools{?top,skip,search,filter,count,orderby,select,expand}";
    urlTplParams := make(map[string]string)
    for idx, item := range pathParameters {
        urlTplParams[idx] = item
    }
    m.pathParameters = pathParameters;
    m.requestAdapter = requestAdapter;
    return m
}
// NewSchoolsRequestBuilder instantiates a new SchoolsRequestBuilder and sets the default values.
func NewSchoolsRequestBuilder(rawUrl string, requestAdapter ida96af0f171bb75f894a4013a6b3146a4397c58f11adb81a2b7cbea9314783a9.RequestAdapter)(*SchoolsRequestBuilder) {
    urlParams := make(map[string]string)
    urlParams["request-raw-url"] = rawUrl
    return NewSchoolsRequestBuilderInternal(urlParams, requestAdapter)
}
// CreateGetRequestInformation schools to which the user belongs. Nullable.
func (m *SchoolsRequestBuilder) CreateGetRequestInformation(options *SchoolsRequestBuilderGetOptions)(*ida96af0f171bb75f894a4013a6b3146a4397c58f11adb81a2b7cbea9314783a9.RequestInformation, error) {
    requestInfo := ida96af0f171bb75f894a4013a6b3146a4397c58f11adb81a2b7cbea9314783a9.NewRequestInformation()
    requestInfo.UrlTemplate = m.urlTemplate
    requestInfo.PathParameters = m.pathParameters
    requestInfo.Method = ida96af0f171bb75f894a4013a6b3146a4397c58f11adb81a2b7cbea9314783a9.GET
    if options != nil && options.Q != nil {
        requestInfo.AddQueryParameters(*(options.Q))
    }
    if options != nil && options.H != nil {
        requestInfo.Headers = options.H
    }
    if options != nil && len(options.O) != 0 {
        err := requestInfo.AddRequestOptions(options.O...)
        if err != nil {
            return nil, err
        }
    }
    return requestInfo, nil
}
// Delta builds and executes requests for operations under \education\me\schools\microsoft.graph.delta()
func (m *SchoolsRequestBuilder) Delta()(*ia797412c79037d67c12341f9d33f0894f60de15efd7141a5da5711a83a65bdfd.DeltaRequestBuilder) {
    return ia797412c79037d67c12341f9d33f0894f60de15efd7141a5da5711a83a65bdfd.NewDeltaRequestBuilderInternal(m.pathParameters, m.requestAdapter);
}
// Get schools to which the user belongs. Nullable.
func (m *SchoolsRequestBuilder) Get(options *SchoolsRequestBuilderGetOptions)(*SchoolsResponse, error) {
    requestInfo, err := m.CreateGetRequestInformation(options);
    if err != nil {
        return nil, err
    }
    res, err := m.requestAdapter.SendAsync(*requestInfo, func () i04eb5309aeaafadd28374d79c8471df9b267510b4dc2e3144c378c50f6fd7b55.Parsable { return NewSchoolsResponse() }, nil, nil)
    if err != nil {
        return nil, err
    }
    return res.(*SchoolsResponse), nil
}
func (m *SchoolsRequestBuilder) Ref()(*icc60562432d4afffaa419e6465a245e8f2b2cf6cd3cb8567d34813eb83c95532.RefRequestBuilder) {
    return icc60562432d4afffaa419e6465a245e8f2b2cf6cd3cb8567d34813eb83c95532.NewRefRequestBuilderInternal(m.pathParameters, m.requestAdapter);
}
